﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Animation;

namespace SLComboBox
{
    public class CustomComboBox : RadComboBox
    {
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            var popup = GetTemplateChild("PART_Popup") as System.Windows.Controls.Primitives.Popup;
            var placementHelper = PopupPlacement.GetPopupPlacement(popup);
            if (placementHelper != null)
            {
                placementHelper.Placement = PlacementMode.Top;
            }
            popup.Opened += popup_Opened;
        }

        protected override void OnIsDropDownOpenChanged(bool oldValue, bool newValue)
        {
            if (!newValue)
            {
                AnimationManager.SetIsAnimationEnabled(this, false);
            }
            base.OnIsDropDownOpenChanged(oldValue, newValue);
            if (!newValue)
            {
                AnimationManager.SetIsAnimationEnabled(this, true);               
            }
        }

        void popup_Opened(object sender, EventArgs e)
        {
            AnimationManager.Stop(this, "Collapse");
            AnimationManager.Play(this, "Expand", null, null, SlideMode.Bottom);
        }
    }
}
